<template>
    <div ref="chatArea" class="chatbox-scroll" @scroll="handleScroll">
        <div v-if="isLoadingTop" class="row">
            <div class="col-12 text-center">
                <q-spinner-dots color="primary" size="lg" class="text-center" />
            </div>
        </div>
        <div v-if="messages.length > 0 && selectedConversationID != ''">
            <message-list-item
                v-for="(message, index) in messages"
                :key="message.id"
                :conversation="conversation"
                :message="message"
                :previousMessage="index > 0 ? messages[index - 1] : null"
                class="chatbox-contain"
            />
        </div>
        <div v-else class="text-center no-message">
            <q-icon size="lg" name="img:icons\sad.png"></q-icon>
            <p class="helvetica-neue font-14 col-12 q-pt-sm">
                {{ $t('home.noContent') }}
            </p>
        </div>
    </div>
</template>

<style lang="scss" scoped>
.btn-scroll {
    position: absolute;
    bottom: 10px;
    right: 15px;
    background: rgba($color: #000000, $alpha: 0.05);
    border-radius: 50%;
}
.loading-top {
    position: absolute;
    top: 20px;
    width: 100%;
    padding-right: 10px;
}
.loading-bottom {
    position: absolute;
    bottom: 0;
    width: 100%;
    padding-right: 10px;
}
</style>

<script lang="ts">
import {
    defineComponent,
    computed,
    ref,
    watch,
    nextTick,
    onMounted
} from 'vue';
import { mapGetters } from 'vuex';
import MessageListItem from '../chats/MessageListItem.vue';
import { useStore } from '../../store';
import { Conversation } from '../../services/models/Conversation';
import { Message } from '../../services/models/Message';
import { debounce, orderBy, size } from 'lodash';
import { MessageDeleteFlag } from '../../services/enums/MessageDeleteFlag';
import { useQuasar } from 'quasar';
import moment from 'moment';
import { MessageListRequestQuery } from '../../services/requests/message/MessageListRequest';
import { useRouter } from 'vue-router';

export default defineComponent({
    name: 'MessageList',
    props: { loading: { type: Boolean } },

    computed: {
        ...mapGetters({
            selectedConversationID: 'conversation/getSelectedConversationID',
            selectedUserID: 'conversation/getSelectedUserID'
        })
    },
    components: {
        MessageListItem
    },
    setup() {
        const $q = useQuasar();
        const store = useStore();
        const chatArea = ref<any>(null);
        const isLoadingTop = ref(false);
        const isLoadingBottom = ref(false);
        const router = useRouter();

        const conversation = computed<Conversation>(
            () => store.state.chat.selectedConversation as Conversation
        );
        const scrollToMessage = computed<Message>(
            () => store.state.chat.scrollToMessage as Message
        );

        const messages = computed<Message[]>(() => {
            const _messages: Message[] = orderBy(
                store.state.message.messages,
                ['createdAt'],
                ['asc']
            );

            return _messages.filter((msg) => {
                return (
                    (msg.conversation?.id ?? msg.conversationId) ==
                        conversation.value.id &&
                    msg.flags?.deleteFlag != MessageDeleteFlag.DELETE_SELF
                );
            });
        });

        let topOffsetDate: Date;
        let currentHeight = 0;
        let isApiCall = false;
        let previousScroll = 0;
        let isNewMessage = false;
        let isInMiddle = false;
        let scrollDirection: 'top' | 'bottom' = 'top';
        let isReset = false;
        let nextIsScrollInMiddle = false;

        // Call API
        const getMessages = async (
            isDownward: 0 | 1 = 0,
            offsetDate?: Date
        ) => {
            const limit = 20;
            if (
                conversation.value &&
                conversation.value?.id != conversation.value?.userId &&
                !(isLoadingTop.value || isLoadingBottom.value)
            ) {
                if (isDownward) {
                    isLoadingBottom.value = true;
                } else {
                    isLoadingTop.value = true;
                }

                isApiCall = true;
                const query: MessageListRequestQuery = {
                    conversationId: conversation.value.id,
                    limit: limit,
                    isDownward,
                    offsetDate
                };

                if (scrollToMessage.value) {
                    isInMiddle = true;
                    nextIsScrollInMiddle = true;
                    query.offsetDate = moment(scrollToMessage.value.createdAt)
                        .subtract(1, 'milliseconds')
                        .toDate();
                    query.isDownward = 1;
                    query.limit = limit;
                }

                await store.dispatch('message/getMessages', query);
                setTimeout(() => {
                    store.dispatch('chat/removeScroll');
                }, 1000);
            }

            scrollToBottom();

            isLoadingTop.value = false;
            isLoadingBottom.value = false;
        };

        const handleScroll = () => {
            const currentScroll: number = chatArea.value?.scrollTop ?? 0;
            const maxScroll: number = chatArea.value?.scrollHeight ?? 0;
            const pageHeight: number = chatArea.value?.offsetHeight ?? 0;

            try {
                if (previousScroll > currentScroll) {
                    scrollDirection = 'top';
                    if (
                        currentScroll < 0.05 * maxScroll ||
                        currentScroll == 0
                    ) {
                        loadTop();
                    }
                } else if (previousScroll < currentScroll) {
                    scrollDirection = 'bottom';

                    if (currentScroll + pageHeight > 0.95 * maxScroll) {
                        if (!isNewMessage) {
                            // check for local storage length
                            checkMessageLength();
                        }
                        isNewMessage = false;
                    }
                }
            } catch (err: any) {}

            previousScroll = currentScroll;
        };

        const scrollToBottom = () => {
            if (nextIsScrollInMiddle) {
                nextIsScrollInMiddle = false;
                scrollDirection = 'bottom';
                isReset = true;

                // Reset messageList
                store.dispatch('chat/removeScroll');
                store.dispatch('message/reset');
            } else {
                scrollDirection = 'bottom';
                nextTick(() => {
                    setTimeout(() => {
                        if (chatArea.value) {
                            chatArea.value.scrollTop =
                                chatArea.value.scrollHeight -
                                chatArea.value.offsetHeight;
                            currentHeight = chatArea.value.scrollHeight;
                        }
                    });
                });

                const messageStatus = store.state.message.messageStatus;
                if (messageStatus == 200 || messageStatus == 201) {
                    // getMessages();
                }
            }
        };

        const loadTop = debounce(
            () => {
                getMessages(0, topOffsetDate);
            },
            500,
            {
                leading: true,
                trailing: false
            }
        );

        const checkMessageLength = () => {
            store.dispatch(
                'message/checkMessageLength',
                store.state.chat.selectedConversation?.id
            );
        };

        const checkRoute = () => {
            if (router.currentRoute.value.path.includes('chat', 1)) {
                getMessages(0, new Date());
            }
        };

        //  state.message.messageListFlag
        store.watch(
            (state) => state.message.messageListFlag,
            () => {
                isNewMessage = true;
                scrollToBottom();
            }
        );

        // state.chat.selectedConversation
        store.watch(
            (state) => state.conversation.selectedConversation,
            () => {
                getMessages(0, new Date());
            }
        );

        // state.message.messages
        store.watch(
            (state) => size(state.message.messages),
            (newLength: number, oldLength: number) => {
                // First load
                if (oldLength == 0 && newLength > 0) {
                    if (!isInMiddle) {
                        scrollToBottom();
                    } else {
                        isInMiddle = false;
                    }
                }
                // Load top
                else {
                    if (currentHeight > 0 && chatArea.value) {
                        if (isApiCall) {
                            if (
                                chatArea.value?.scrollTop <
                                0.15 * chatArea.value?.scrollHeight
                            ) {
                                nextTick(() => {
                                    setTimeout(() => {
                                        if (chatArea.value) {
                                            chatArea.value.scrollTop =
                                                chatArea.value.scrollHeight -
                                                currentHeight;
                                        }
                                    });
                                });
                            }
                        } else {
                            // New message coming in
                            if (
                                (chatArea.value?.scrollTop as number) +
                                    (chatArea.value?.offsetHeight as number) >
                                0.95 * chatArea.value?.scrollHeight
                            ) {
                                isNewMessage = true;
                                scrollToBottom();
                            }
                        }
                    }
                    // Jump scroll
                    else {
                        if (!isInMiddle) {
                            if (scrollDirection == 'bottom') {
                                if (isReset) {
                                    isReset = false;
                                    scrollToBottom();
                                } else {
                                    nextTick(() => {
                                        setTimeout(() => {
                                            if (chatArea.value) {
                                                chatArea.value.scrollTop =
                                                    currentHeight -
                                                    chatArea.value
                                                        ?.offsetHeight;
                                            }
                                        });
                                    });
                                }
                            } else {
                                nextTick(() => {
                                    setTimeout(() => {
                                        if (chatArea.value) {
                                            chatArea.value.scrollTop =
                                                chatArea.value.scrollHeight -
                                                currentHeight;
                                        }
                                    });
                                });
                            }
                        } else {
                            nextTick(() => {
                                setTimeout(() => {
                                    if (chatArea.value) {
                                        chatArea.value.scrollTop = 0;
                                    }
                                });
                            });
                        }
                    }
                }

                isApiCall = false;
                currentHeight = chatArea.value?.scrollHeight;
                topOffsetDate = messages.value?.[0]?.createdAt ?? null;
            }
        );

        // $q.appVisible
        watch(
            () => $q.appVisible,
            (isVisible) => {
                if (
                    isVisible &&
                    (store.state.conversation.conversations[
                        conversation.value?.id
                    ]?.totals?.totalUnread ?? 0) > 0
                ) {
                    scrollToBottom();
                    setTimeout(() => {
                        store.dispatch(
                            'conversation/clearTotalUnread',
                            conversation.value
                        );
                    }, 2000);
                }
            }
        );

        onMounted(checkRoute);

        watch(router.currentRoute, () => {
            checkRoute();
        });

        return {
            conversation,
            chatArea,
            messages,
            scrollToBottom,
            isLoadingTop,
            isLoadingBottom,
            handleScroll
        };
    }
});
</script>
